%{!?perl_archlib:    %define perl_archlib    %(eval "`%{__perl} -V:installarchlib`"   ; echo $installarchlib)}
%{!?perl_vendorlib:  %define perl_vendorlib  %(eval "`%{__perl} -V:installvendorlib`" ; echo $installvendorlib)}
%{!?perl_vendorarch: %define perl_vendorarch %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)}
%{!?perl_version:    %define perl_version    %(eval "`%{__perl} -V:version`"          ; echo $version)}

%{!?python_sitelib:  %define python_sitelib  %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}
%{!?python_abi:      %define python_abi      %(%{__python} -c "import sys; print sys.version[:3]")}

%{!?ruby_sitelib:    %define ruby_sitelib    %(ruby -rrbconfig -e "puts Config::CONFIG['sitelibdir']"   2>/dev/null || echo 'None')}
%{!?ruby_sitearch:   %define ruby_sitearch   %(ruby -rrbconfig -e "puts Config::CONFIG['sitearchdir']"  2>/dev/null || echo 'None')}
%{!?ruby_abi:        %define ruby_abi        %(ruby -rrbconfig -e "puts Config::CONFIG['ruby_version']" 2>/dev/null || echo 'None')}


Summary:        Time-series data logging and graphing tools
Name:           rrdtool
Version:        1.3.8
Release:        2%{?dist}%{?pext}
License:        GPL
Group:          Applications/Databases
Source0:        http://oss.oetiker.ch/%{name}/pub/%{name}-%{version}.tar.gz
Patch0:         %{name}-1.3.8-ruby.patch
URL:            http://oss.oetiker.ch/%{name}/
Buildroot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:         Tobias Oetiker <tobi@oetiker.ch>
Requires:       bitstream-vera-fonts
BuildRequires:  bitstream-vera-fonts cairo-devel gettext
BuildRequires:  intltool libxml2-devel pango-devel pkgconfig
BuildRequires:  perl(Config) perl(ExtUtils::MakeMaker)
BuildRequires:  python-devel >= 2.3 python-setuptools
BuildRequires:  ruby ruby-devel

%description
RRD is the Acronym for Round Robin Database. RRD is a system to store and
display time-series data (i.e. network bandwidth, machine-room temperature,
server load average). It stores the data in a very compact way that will not
expand over time, and it presents useful graphs by processing the data to
enforce a certain data density.


%package        devel
Summary:        Development tools for RRDTool
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       cairo-devel libxml2-devel pango-devel
Requires:       pkgconfig

%description    devel
The %{name}-devel package contains the static libraries and header files
for developing software using RRDTool.


%package     -n perl-%{name}
Summary:        Perl bindings for RRDTool
Group:          Development/Libraries
Provides:       perl(RRDp) = 1.3008
Provides:       perl(RRDs) = 1.3008
Requires:       %{name} = %{version}-%{release}
Requires:       perl(:MODULE_COMPAT_%{perl_version})

%description -n perl-%{name}
The perl-%{name} package contains the Perl bindings for RRDTool.


%package     -n python-%{name}
Summary:        Python bindings for RRDTool
License:        LGPL
Group:          Development/Languages
Provides:       python(%{name}) = 0.2.1
Requires:       %{name} = %{version}-%{release}

%description -n python-%{name}
The python-%{name} package contains the Python bindings for RRDTool.


%package     -n ruby-%{name}
Summary:        Ruby bindings for RRDTool
Group:          Development/Languages
Provides:       ruby(RRD) = %{version}
Requires:       %{name} = %{version}-%{release}
Requires:       ruby(abi) = %{ruby_abi}

%description -n ruby-%{name}
The ruby-%{name} package contains the Ruby bindings for RRDTool.


%prep
%setup -q
%patch0 -p1


%build
%configure \
	--enable-shared \
	--enable-static \
	--disable-perl  \
	--disable-ruby  \
	--disable-tcl   \
	--disable-python

%{__make} %{?_smp_mflags}

# Build Perl bindings
for TYPE in piped shared; do
  pushd bindings/perl-${TYPE}

  %{__perl} \
	Makefile.PL          \
	INSTALLDIRS="vendor" \
	OPTIMIZE="${RPM_OPT_FLAGS}"

  %{__make} %{?_smp_mflags}

  popd
done

# Build Python bindings
pushd bindings/python
%{__python} -c 'import setuptools; execfile("setup.py")' build
popd

# Build Ruby bindings
pushd bindings/ruby
export CONFIGURE_ARGS="--with-cflags=\"${RPM_OPT_FLAGS}\""
ruby extconf.rb
%{__make} %{?_smp_mflags}
popd


%check
export LD_LIBRARY_PATH=%{_builddir}/%{name}-%{version}/src/.libs

for TYPE in piped shared; do
  pushd bindings/perl-${TYPE}
  %{__make} test
  popd
done

pushd bindings/ruby
ruby test.rb
popd


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_prefix}

%{__make} \
	DESTDIR=${RPM_BUILD_ROOT} \
	install

%{__rm} -rf ${RPM_BUILD_ROOT}%{_docdir}
%{__rm} -f  ${RPM_BUILD_ROOT}%{_libdir}/lib*.so.?

# Install Perl bindings
for TYPE in piped shared; do
  pushd bindings/perl-${TYPE}

  %{__make} \
	PERL_INSTALL_ROOT=${RPM_BUILD_ROOT} \
	pure_install

  popd
done

find ${RPM_BUILD_ROOT}%{perl_archlib}    -type f -name "perl*.pod"       -exec %{__rm} -f {} \;
find ${RPM_BUILD_ROOT}%{perl_vendorarch} -type f -name "ntmake.pl"       -exec %{__rm} -f {} \;
find ${RPM_BUILD_ROOT}%{perl_vendorarch} -type f -name ".packlist"       -exec %{__rm} -f {} \;
find ${RPM_BUILD_ROOT}%{perl_vendorarch} -type f -name "*.bs" -a -size 0 -exec %{__rm} -f {} \;
find ${RPM_BUILD_ROOT}%{perl_vendorarch} -depth  -empty -type d          -exec rmdir      {} \;

%{__chmod} -R u+w ${RPM_BUILD_ROOT}%{perl_vendorarch}/*

# Install Python bindings
pushd bindings/python
%{__python} -c 'import setuptools; execfile("setup.py")' install \
	--skip-build -O1 --root ${RPM_BUILD_ROOT}
popd

# Install Ruby bindings
pushd bindings/ruby
%{__make} \
	DESTDIR=${RPM_BUILD_ROOT} \
	install
popd


%post -p /sbin/ldconfig


%postun -p /sbin/ldconfig


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc CHANGES CONTRIBUTORS COPY* NEWS README THREADS TODO
%doc --parents doc/rrd*.html doc/rrd*.txt *.ico
%{_bindir}/rrdcgi
%{_bindir}/rrdtool
%{_bindir}/rrdupdate
%{_libdir}/librrd.so.*
%{_libdir}/librrd_th.so.*
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/examples
%{_datadir}/%{name}/examples/*.cgi
%{_mandir}/man1/*.1*

%files devel
%defattr(-,root,root)
%{_includedir}/rrd.h
%{_includedir}/rrd_format.h
%{_libdir}/librrd.*a
%{_libdir}/librrd.so
%{_libdir}/librrd_th.*a
%{_libdir}/librrd_th.so
%{_libdir}/pkgconfig/librrd.pc

%files -n perl-%{name}
%defattr(-,root,root)
%doc doc/{RRDp,RRDs}.html
%{perl_vendorlib}/RRDp.pm
%{perl_vendorarch}/auto/RRDs
%{perl_vendorarch}/RRDs.pm
%{_datadir}/%{name}/examples/*.pl
%{_mandir}/man3/*.3*

%files -n python-%{name}
%defattr(-,root,root)
%doc bindings/python/{ACKNOWLEDGEMENT,AUTHORS,COPYING,README}
%{python_sitearch}/rrdtoolmodule.so
%{python_sitearch}/*.egg-info

%files -n ruby-%{name}
%defattr(-,root,root)
%doc bindings/ruby/{CHANGES,README}
%{ruby_sitearch}/RRD.so


%changelog
* Tue Aug 25 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.8-2
- Build Ruby bindings

* Fri May 29 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.8-1
- New version (1.3.8)

* Thu Apr 09 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.7-1
- New version (1.3.7)

* Sat Jan 24 2009 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.6-1
- New version (1.3.6)

* Fri Dec 19 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.5-1
- New version (1.3.5)

* Sun Nov 23 2008 Peter Pramberger <peterpramb@member.fsf.org> - 1.3.4-1
- Upgrade version (1.3.4)

* Wed May 09 2007 peter.pramberger@member.fsf.org 1.2.23-4
- new version (1.2.23)

* Thu Feb 08 2007 peter.pramberger@member.fsf.org 1.2.19-4
- new version (1.2.19)

* Thu Sep 07 2006 peter.pramberger@member.fsf.org
- new version (1.2.15)

* Fri Mar 03 2006 peter.pramberger@member.fsf.org
- created
